<?php    /*************             dump_PDO             ***************/
function istring($types, $type) {               // voir $types ligne 14
    foreach($types as $t) if(strpos($type, $t) !== false) return "'";
    return "";                                  // type n'est pas un string.
}// return "'" pour 1 type string

function dump_PDO($bdd, $fichier, &$mode) {     // bdd=instance PDO / 1,2 ou 3.
  if(!file_exists($fichier)) {                  // crasement interdit
    $req = $bdd->query('SELECT DATABASE( )');   // nom de la base lie  bdd
    $cur = $req->fetch(); $req->closeCursor(); $bd = '`'.$cur[0].'`';
    // vrifier si : date.timezone = Europe/Paris dans php.ini :
    $drops = '-- dump de la base : '.$bd.' au '.date('d/m/Y H:i');
    // MySql 5.0  11.4 prcise les types string ; ils "contiennent" :
$types=array('char','blob','text','enum','set','date','time','year','binary');
    $creations = $insertions = "";    
    // SET : pour tables avec contraintes / DROP  : effacement des tables :
    $deb_drop = "\n\nSET FOREIGN_KEY_CHECKS = 0;\n\nDROP TABLE IF EXISTS\n  `";
    $req  = $bdd->query('SHOW TABLES');         // Toutes les tables de bdd.
    $tables = $req->fetchall(); $req->closeCursor();    
    $msg = '<br />Tables de '.$bd.'  sauvegarder :';
    foreach($tables as $tab) {                  // On reprend chaque table :
        $msg .= '<br />`'.$tab[0].'`';          // son nom,
        $req  = $bdd->query('SHOW CREATE TABLE '.$tab[0]); // MySql fait tout !
        $table = $req->fetch(); $req->closeCursor();
        if($mode == 1 || $mode == 2) {      // structure ou totalit de la BDD
            $drops .= $deb_drop.$tab[0]; $deb_drop = "`,\n  `"; // Suppression
            $creations .= $table[1].";\n\n"; }  // sa description complte,
        if($mode > 1) { // donnes ou totalit. 1 requte/table : vitesse x10 :
            $insertions .= "INSERT INTO `".$table[0]."` VALUES\n";
            $req = $bdd->query('SELECT * FROM '.$table[0]);     // donnes.
            $donnees = $req->fetchall(); $req->closeCursor();
            $req = $bdd->query('SHOW COLUMNS FROM '.$table[0]); // format cols
            $colonnes = $req->fetchall(); $req->closeCursor();
            $format="";  // Format des donnes de la table mis dans 1 tableau :
            foreach($colonnes as $col) $format[]=istring($types, $col['Type']);
            $deb = "";
            foreach($donnees as $donnee) {
                $deb .= "("; $i = 0;            // dbut d'1 ligne de donnes
                foreach($format as $form) {     // Les strings sont 'emballes':
                    $insertions .= $deb.$form.addslashes($donnee[$i++]).$form;
                    $deb =  ", "; } $deb = "),\n";      // , =suivante  ), =fin
            }    $insertions .= ");\n\n"; } }           // ); =fin des donnes.
    $drops .= "`;\n\n";                                 // Fin de DROP_TABLE
    $insertions .= "SET FOREIGN_KEY_CHECKS = 1\n\n";    // Ne pas l'oublier !!
    $fichierDump = fopen($fichier, "wb");               // cration/destruction
    $fich = array($drops, $creations, $insertions);     // Tout est l.
    foreach($fich as $f) if(fwrite($fichierDump, $f)===false) {
        $mode=0; $msg = $fichier." : Echec d'criture."; }
    fclose($fichierDump);
    $msg .= '<br />Sauvegarde de '.$bd.' termine<br />'; }
  else { $mode=0; $msg = $fichier.' existe dj.'; }    // mode = 0 => Erreur
  return $msg;                                          // Aucun affichage ici.
}        /*********************   dump_PDO   ************************/?>
